var animation;
var text;
var width,height;
var start_time;

function init()
{
	start_time=new Date().getTime();

	text=document.getElementById("text");

	width=256;
	height=256;
	t=0;

	if(window.widget)
	{
	    widget.onshow=start_animation;
	    widget.onhide=stop_animation;
	}

	start_animation();
}

function start_animation()
{
	if(animation) return;

	var canvas_el=document.getElementById("canvas");
	var c=canvas_el.getContext("2d");

	var interval=25;
	var dt=interval/1000;
	var text_angle=5.75;
//	var text_angle=3;
	var rotation_speed=0.7;

	animation=setInterval(function() {
		var t=(new Date().getTime()-start_time)/1000;
		c.clearRect(0,0,width,height);

		var start_angle=t*rotation_speed;
		var end_angle=start_angle+2*Math.PI;
		var start_index=Math.floor(start_angle/text_angle);
		var end_index=Math.floor(end_angle/text_angle);

		for(var i=start_index;i<=end_index;i++)
		draw_text(c,i*text_angle,(i+1)*text_angle,start_angle,end_angle);

		t+=dt;
	},interval);
}

function draw_text(c,text_start_angle,text_end_angle,view_start_angle,view_end_angle)
{
	c.save();

	c.translate(width/2,height/2);
	c.rotate(-view_start_angle);
	c.translate(-width/2,-height/2);

	if(text_start_angle<view_start_angle || text_end_angle>view_end_angle)
	{
		c.beginPath();
		c.moveTo(width/2,height/2);

		if(text_start_angle<view_start_angle)
		c.arc(width/2,height/2,width/2,view_start_angle,text_end_angle,false);
		else if(text_end_angle>view_end_angle)
		c.arc(width/2,height/2,width/2,text_start_angle,view_end_angle,false);

		c.closePath();
		c.clip();
	}

	c.translate(width/2,height/2);
	c.rotate(text_start_angle);
	c.translate(-width/2,-height/2);

	c.drawImage(text,0,0,width,height);

	c.restore();
}

function stop_animation()
{
	if(animation)
	{
		clearInterval(animation);
		animation=null;
	}
}

